﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Data.Entity;
using System.Linq;

namespace EntityFrameworkMySQL.Test
{
    [TestClass]
    public class UnitTest1
    {
        static UnitTest1()
        {
            //DbConfiguration.SetConfiguration(new MySqlEFConfiguration());
        }

        [ClassCleanup]
        public static void _ClassCleanup()
        {
            //DropDb();
        }

        [ClassInitialize]
        public static void _ClassInitialize(TestContext tc)
        {
            RecreateDb();
        }

        [TestMethod]
        public void CanFindRegistrazioniOperatoreDaValidare()
        {
            using (var cxt = new Model1Container())
            {
                var query = from customer in cxt.Set<Customer>()
                            let firstOrderTimestamp = (from order in customer.Orders
                                                       orderby order.Timestamp
                                                       select (DateTime?)order.Timestamp).FirstOrDefault()
                            select firstOrderTimestamp;

                Console.WriteLine(query);

                query.ToArray();
            }
        }

        [TestMethod]
        public void CanFindRegistrazioniOperatoreDaValidare2()
        {
            using (var cxt = new Model1Container())
            {
                // By means of grouping
                {
                    var fo = from op in cxt.Set<Customer>()
                             join st in cxt.Set<Order>()
                             on op.Id equals st.CustomerId
                             select new { op.Id, st.Timestamp };

                    var go = from a in fo
                             group a by a.Id into g
                             select g;

                    var po = from g in go
                             let opId = g.Key
                             let date = g.OrderBy(_ => _.Timestamp).Select(_ => _.Timestamp)
                             let ok = date.Count() > 0
                             let firstOrDef = ok ? date.FirstOrDefault() : DateTime.MinValue
                             select new { opId, firstOrDef };

                    Console.WriteLine(po);

                    po.ToArray();
                }
            }
        }

        [TestMethod]
        public void CanQuery()
        {
            using (var cxt = new Model1Container())
            {
                cxt.Set<Customer>().Count();
            }
        }

        private static void DropDb()
        {
            using (var cxt = new Model1Container())
            {
                cxt.Database.Delete();
            }
        }

        private static void RecreateDb()
        {
            var initializer = new DropCreateDatabaseAlways<Model1Container>();

            using (var cxt = new Model1Container())
            {
                initializer.InitializeDatabase(cxt);
            }
        }
    }
}